Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.sql
Class BatchUpdateException

    java.lang.Object
      |
      +--java.lang.Throwable
            |
            +--java.lang.Exception
                  |
                  +--java.sql.SQLException
                        |
                        +--java.sql.BatchUpdateException

All Implemented Interfaces:
  Serializable

public class BatchUpdateException
extends SQLException

An exception thrown when an error occurs during a batch update operation. In addition to the information provided by `SQLException`, a `BatchUpdateException` provides the update counts for all commands that were executed successfully during the batch update, that is, all commands that were executed before the error occurred. The order of elements in an array of update counts corresponds to the order in which commands were added to the batch.

After a command in a batch update fails to execute properly and a `BatchUpdateException` is thrown, the driver may or may not continue to process the remaining commands in the batch. If the driver continues processing after a failure, the array returned by the method `BatchUpdateException.getUpdateCounts` will have an element for every command in the batch rather than only elements for the commands that executed successfully before the error. In the case where the driver continues processing commands, the array element for any command that failed is `-3`.

This class is new in the JDBC 2.0 API.

See Also:
  Serialized Form

Constructor Summary
`BatchUpdateException()` Constructs a `BatchUpdateException` object with the reason, SQLState, and update count initialized to `null` and the vendor code initialized to 0.
`BatchUpdateException(int[] updateCounts)` Constructs a `BatchUpdateException` initialized to `null` for the reason and SQLState and 0 for the vendor code.
`BatchUpdateException(String reason, int[] updateCounts)` Constructs a `BatchUpdateException` initialized with `reason`, `updateCounts` and `null` for the SQLState and 0 for the vendorCode.
`BatchUpdateException(String reason, String SQLState, int[] updateCounts)` Constructs a `BatchUpdateException` initialized with the given arguments (`reason`, `SQLState`, and `updateCounts`) and 0 for the vendor code.
`BatchUpdateException(String reason, String SQLState, int vendorCode, int[] updateCounts)` Constructs a fully-specified `BatchUpdateException` object, initializing it with the given values.

Method Summary
`int[]` | `getUpdateCounts()` Retrieves the update count for each update statement in the batch update that executed successfully before this exception occurred.

Methods inherited from class java.sql.SQLException
`getErrorCode, getNextException, getSQLState, setNextException`

Methods inherited from class java.lang.Throwable
`fillInStackTrace, getLocalizedMessage, getMessage, printStackTrace, printStackTrace, printStackTrace, toString`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### BatchUpdateException

    public BatchUpdateException(String reason,
                                String SQLState,
                                int vendorCode,
                                int[] updateCounts)

  Constructs a fully-specified `BatchUpdateException` object, initializing it with the given values.
  Parameters:
    `reason` - a description of the error
    `SQLState` - an X/OPEN code identifying the error
    `vendorCode` - an exception code used by a particular database vendor
    `updateCounts` - an array of `int`, with each element indicating the update count for a SQL command that executed successfully before the exception was thrown
  Since:
    1.2
  See Also:
    What Is in the JDBC 2.0 API

### BatchUpdateException

    public BatchUpdateException(String reason,
                                String SQLState,
                                int[] updateCounts)

  Constructs a `BatchUpdateException` initialized with the given arguments (`reason`, `SQLState`, and `updateCounts`) and 0 for the vendor code.
  Parameters:
    `reason` - a description of the exception
    `SQLState` - an X/OPEN code identifying the exception
    `updateCounts` - an array of `int`, with each element indicating the update count for a SQL command that executed successfully before the exception was thrown
  Since:
    1.2
  See Also:
    What Is in the JDBC 2.0 API

### BatchUpdateException

    public BatchUpdateException(String reason,
                                int[] updateCounts)

  Constructs a `BatchUpdateException` initialized with `reason`, `updateCounts` and `null` for the SQLState and 0 for the vendorCode.
  Parameters:
    `reason` - a description of the exception
    `updateCounts` - an array of `int`, with each element indicating the update count for a SQL command that executed successfully before the exception was thrown
  Since:
    1.2
  See Also:
    What Is in the JDBC 2.0 API

### BatchUpdateException

    public BatchUpdateException(int[] updateCounts)

  Constructs a `BatchUpdateException` initialized to `null` for the reason and SQLState and 0 for the vendor code.
  Parameters:
    `updateCounts` - an array of `int`, with each element indicating the update count for a SQL command that executed successfully before the exception was thrown
  Since:
    1.2
  See Also:
    What Is in the JDBC 2.0 API

### BatchUpdateException

    public BatchUpdateException()

  Constructs a `BatchUpdateException` object with the reason, SQLState, and update count initialized to `null` and the vendor code initialized to 0.
  Since:
    1.2
  See Also:
    What Is in the JDBC 2.0 API

Method Detail

### getUpdateCounts

    public int[] getUpdateCounts()

  Retrieves the update count for each update statement in the batch update that executed successfully before this exception occurred. A driver that implements batch updates may or may not continue to process the remaining commands in a batch when one of the commands fails to execute properly. If the driver continues processing commands, the array returned by this method will have as many elements as there are commands in the batch; otherwise, it will contain an update count for each command that executed successfully before the `BatchUpdateException` was thrown.

  The possible return values for this method were modified for the Java 2 SDK, Standard Edition, version 1.3. This was done to accommodate the new option of continuing to process commands in a batch update after a `BatchUpdateException` object has been thrown.

  Returns:
    an array of `int` containing the update counts for the updates that were executed successfully before this error occurred. Or, if the driver continues to process commands after an error, one of the following for every command in the batch:
    1. an update count
    2. `-2` to indicate that the command executed successfully but the number of rows affected is unknown
    3. `-3` to indicate that the command failed to execute successfully
  Since:
    1.3
  See Also:
    What Is in the JDBC 2.0 API

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2001 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.